

#include <linux/init.h>

#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/cdev.h>
#include <linux/types.h>
#include <linux/fs.h>
#include  <asm/uaccess.h>
#include <asm/uaccess.h>
#include "my_ioctl.h"

int major=250;
int minor=1;

int num=20 ; //for ioctl

dev_t dev;
struct cdev *my_cdev;

char kbuf[10]="hai cdac";



int  my_open (struct inode *, struct file *);

int  my_release (struct inode *, struct file *);


ssize_t my_read (struct file *, char __user *, size_t, loff_t *);
ssize_t my_write (struct file *, const char __user *, size_t, loff_t *);
int  my_ioctl (struct inode *, struct file *, unsigned int, unsigned long);



struct file_operations  my_fileops = {
  .owner =    THIS_MODULE,
  .open =     my_open,
  .read =     my_read,
  .write =    my_write,
  .ioctl =    my_ioctl, 
  .release =  my_release
};


static int hello_init(void)
{
  int ret;
  printk(KERN_ALERT"init: Hello loaded\n");

  // Making the device from major,minor numbers. dev will hold info about it.

  dev=MKDEV(major,minor);


  //Registering the device 
  //register_chrdev_region(dev_t first, unsigned int count,   char *name);

  ret=register_chrdev_region(dev, 1,"sunil");
  if (ret !=0 )
    {
      printk( " init: Error registering the  Device \n");

      return -1;
    }
  
  //allocate the and initialiaing  

  my_cdev = cdev_alloc( );
  my_cdev->ops = &my_fileops;

  ret=cdev_add(my_cdev, dev , 1); // attaching my_cdev and dev and adding it to kernel
  if (ret !=0 )
    {
      printk( " init: Error adding   Device \n");
      cdev_del(my_cdev);  // remove the cdev and un register device
      unregister_chrdev_region(dev, 1)  ;
      return -1;
    }
   
 
  return (0);
}

int my_open (struct inode *i, struct file *f)
{
  printk(" open:In open\n");
  return 0;
}

int   my_release (struct inode *i, struct file *f)
{
  printk(" release:In Release \n");
  return 0;
}


ssize_t my_read(struct file *filp, char __user *buf, size_t count, loff_t *offp)
 {
   int ret;
  
   printk("read: Reading %d bytes \n ",count);
   
   ret =copy_to_user( buf,kbuf,count);
   if (ret ==count) 
     {
       printk("read: Error in Read ret is %d \n",ret );
       return -1;
     }
   printk("read: %s  data transferd  to user \n ",kbuf );
   return count-ret ;
 } 


ssize_t my_write (struct file *filp, const char __user *buf , size_t count, loff_t * of)
{
  int ret;
  printk("write:write %d bytes data is : %s:   \n",count,buf);
  ret = copy_from_user(kbuf,buf,count);
  
  if (ret ==count)
    {
      printk("write:Error in write  ret from copy_from_user is %d\n",ret);
      return -1;
    }

  
  return count-ret;
}


int my_ioctl (struct inode *inode, struct file *flp, unsigned int cmd, unsigned long arg)
{
  int ret;
  switch (cmd)    
    {
           
    case SETNUM:
      num=(int)arg;
      printk("ioct:SETNUM set num to %d\n",num);
      break;
    case GETNUM:
      ret=copy_to_user(  (int*)arg,&num, sizeof(num));
      if (ret ==sizeof(num)) 
     {
       printk("ioctl: Error in GETNUM \n");
       return -1;
     }
      printk("ioctl:GETNUM copied %d  %d to user space\n", num, *((int*)arg));
      break;
    default:
      printk(" ioctl:Invalid command\n");
      return -1;
      
    }
   
  return 0;
}


static void hello_exit(void)
{
  printk(KERN_ALERT"exit:leaving module\n");
  cdev_del(my_cdev);  // remove the cdev and un register device                
  unregister_chrdev_region(dev, 1);

}
 
module_init( hello_init);
module_exit( hello_exit);
 
